package operationword;

import java.awt.*;
import java.awt.event.*;

/**
 * <p>Title: Computerised Operation Word Span Test</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author tylin
 * @version 1.0
 */

public class MessagePanel extends java.awt.Panel {
  Panel topPanel = new Panel();
  BorderLayout borderLayout1 = new BorderLayout();
  BorderLayout borderLayout2 = new BorderLayout();
  Panel panel1 = new Panel();
  Button butOK = new Button();
  Controller controller;
  TextArea areaMessage = new TextArea("",0,0, TextArea.SCROLLBARS_VERTICAL_ONLY);

  public MessagePanel(Controller pCon, String pMessage) {
    this.controller= pCon;
    try {
      jbInit();
      areaMessage.setText(pMessage);
//    butOK.getCursor();
//    butOK.requestFocus();

    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  private void jbInit() throws Exception {
    this.setBackground(Color.lightGray);
    this.setLayout(borderLayout2);
    topPanel.setLayout(borderLayout1);
    topPanel.setBackground(Color.white);
    butOK.setLabel("OK");
    butOK.setVisible(true);
    butOK.addActionListener(new MessagePanel_butOK_actionAdapter(this));
    panel1.setBackground(Color.white);
    areaMessage.setColumns(20);
    areaMessage.setEditable(true);
    areaMessage.setSelectionStart(0);
    areaMessage.setText("test");
    this.add(topPanel,  BorderLayout.CENTER);
    topPanel.add(areaMessage, BorderLayout.CENTER);
    this.add(panel1,  BorderLayout.SOUTH);
    panel1.add(butOK, null);
  }

  void butOK_actionPerformed(ActionEvent e) {
    this.controller.nextStep();
  }




}

class MessagePanel_butOK_actionAdapter implements java.awt.event.ActionListener {
  MessagePanel adaptee;

  MessagePanel_butOK_actionAdapter(MessagePanel adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.butOK_actionPerformed(e);
  }
}
