package operationword;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.util.Vector;
//import javax.swing.UIManager;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author tylin
 * @version 1.0
 */

public class OWInterface extends Applet {
  private boolean isStandalone = false;
  BorderLayout borderLayout2 = new BorderLayout();
  Panel switchPanel = new Panel();
  Controller controller;

  //parameters from Applet
  String studentIDVar;
  String server;
  String user;
  String pw;
  String dbName;
  String usertestsTable; //table to store user tests results
  int wordSet=1; //word set, 1 is Engles 60 words, 2 is tt's, 3 is German
  boolean emailToAdmin = false; //send email to admin after task or not, value from parameter
  boolean enforceDBCheck = true; //to enforce checking the connection to db or not



  //Get a parameter value
  public String getParameter(String key, String def) {
    return isStandalone ? System.getProperty(key, def) :
      (getParameter(key) != null ? getParameter(key) : def);
  }

  //Construct the applet
  public OWInterface() {
    System.out.println("Web-OPWORD started");
  }

  public void ChangePanel(Panel pNewPanel){
   this.remove(switchPanel);
   this.repaint();
   switchPanel = pNewPanel;
   this.add(switchPanel, BorderLayout.CENTER);
   this.validate();
  }

  /*
  public void ChangePanel(Panel pNewPanel){
   this.remove(switchPanel);
   switchPanel = pNewPanel;
   this.add(switchPanel, BorderLayout.CENTER);
   this.validate();

  }


   */

  /**
   * Return a reversed string
   * @param text
   * @return
   */
  private String reverse(String text){
    // 'text' is the String to be reversed

    // Start by creating a character array of exactly the same length as `text'.
    //  This is because Java allows individual elements of an array to be changed,
    //  but not individual characters of a String
    char reversedText[] = new char[text.length()];

    // Now move each character in `text' to the right place in `reversedText'
    for (int i = 0; i < text.length(); i++)
      reversedText[i] = text.charAt(text.length() - i - 1);

      // `reversedText' is an array; Java will not allow us to use `drawString' to
      //   print an array (it can only print Strings). So we create a new String
      //   that has exactly the same text as `reversedtext'
    String reversedTextString = new String(reversedText);
    return reversedTextString;

  }

  /**
   * decode an encoded string
   * string position start from 1 not 0
   * embed $seed into a 100 characters long string
   * the start position of rev($seed) is in position 5 and 6
   * the length of $seed is in position 95 and 96 (assume length of $seed should not be more than 99)
   * the length of $seed should be in fact less than 95 - 20 = 75 character
   *
   * @param pEncoded
   * @return
   *
   */
  private String deCode(String pEncoded){
    if(pEncoded.length() != 100){
      System.out.println("Internal Error: Error Code 101");
      System.exit(101);
    }
    int pos = Integer.parseInt( pEncoded.substring(4,6));
    int len = Integer.parseInt(pEncoded.substring(94,96));
    //System.out.println(len + ":" + pos);
    String rev = pEncoded.substring(pos-1, pos+len-1);
    //System.out.println(rev);

    return this.reverse(rev);

  }

  //Initialize the applet
  public void init() {
    try {
      studentIDVar = this.getParameter("p1", "");
      server = this.getParameter("p2", "");
      user = this.getParameter("p3", "");
      pw = this.getParameter("p4", "");
      dbName = this.getParameter("p5", "");

      emailToAdmin = (this.getParameter("p6", "").compareTo("1") ==0);
      wordSet = Integer.parseInt( this.getParameter("p7", ""));
      usertestsTable = this.getParameter("p8", "");
      enforceDBCheck = (this.getParameter("p9", "").compareTo("true")==0);


      user = this.deCode(user);
      pw = this.deCode(pw);
      dbName = this.deCode(dbName);
      usertestsTable = this.deCode(usertestsTable);
      controller = new Controller(this, server, user, pw, dbName, wordSet, usertestsTable, enforceDBCheck);
      controller.setStudentID(studentIDVar);


      //System.out.println(this.deCode("b+Lg09A.tla#l;MenX.IktEL08u`t:YGM%aPr1r.SfE_KBzw)*ivGUW~soX~NRR;_eX`H$QR3RQa|l.N5z,juY_uNk/cx003?Sfj")) ;

      jbInit();
      controller.nextStep();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  //Component initialization
  private void jbInit() throws Exception {
    this.setBackground(Color.white);
    this.setLayout(borderLayout2);
    switchPanel = new Panel();
    this.add(switchPanel, BorderLayout.CENTER);

    //switchPanel = new DisplayPanel();
    //this.add(switchPanel, BorderLayout.CENTER);

    //Vector answerVector = new Vector(5);
    //switchPanel = new TestPanel(5, answerVector);
    //this.add(switchPanel, BorderLayout.CENTER);
    //this.remove(switchPanel);
    //this.add(switchPanel, BorderLayout.CENTER);
  }


  //Start the applet
  public void start() {
  }
  //Stop the applet
  public void stop() {
  }
  //Destroy the applet
  public void destroy() {
  }
  //Get Applet information
  public String getAppletInfo() {
    return "Applet Information";
  }
  //Get parameter info
  public String[][] getParameterInfo() {
    String[][] pinfo =
      {
      {"studentID", "String", "StudentID"},
      };
    return pinfo;
  }
}