package operationword;

import java.util.Vector;
import java.util.Random;
/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author tylin
 * @version 1.0
 */

public class Operation {
  //Vector operationVector = new Vector(); //used to store the opearation string
  //Vector answerVector = new Vector(); //used to store true/false for each op string
  String[] operationArray; //used to store the opearation string
  boolean[] answerArray; //used to store true/false for each op string

  /**
   *
   * @param pNoOfOp number of operation string to create
   */
  public Operation(int pNoOfOp) {
    operationArray = new String[pNoOfOp];
    answerArray = new boolean[pNoOfOp];
    init(pNoOfOp);
  }

  void init(int pNoOfOp){
    Random ran = new Random();
    for(int k=0; k <pNoOfOp;k++){
      String firstOp = null; //first operation
      String secondOp = null; // has format: firstOp operant int
      String answer = null; //answer to display in the operation string, could be correct or wrong answer dep on correctAns
      boolean correctAns = ran.nextBoolean(); //if correctAns, the op string is true, otherwise false
      boolean mult = ran.nextBoolean(); //if mult is false, then this is a division
      boolean add = ran.nextBoolean(); //if add is false, then this is a reduction

      //******** make firstOp ************
      int a = ran.nextInt(4) + 1;
      int b = ran.nextInt(4) + 1;
      int c = a * b;
      int totalSoFar = 0; //this is the correct answer
      if (mult) {
        firstOp = "(" + a + " X " + b + ")";
        totalSoFar = c;
      }
      else { //if divide
        firstOp = "(" + c + " / " + a + ")";
        totalSoFar = b;
      }
      //*******end firstOp, begin secondOp
       int d = ran.nextInt(8) + 1;
      if (add) {
        secondOp = firstOp + " + " + d;
        totalSoFar += d;
      }
      else {
        int diff = totalSoFar;
        diff = totalSoFar - d;
        while (diff < 0) {
          d--;
          diff = totalSoFar - d;
        }
        secondOp = firstOp + " - " + d;
        totalSoFar -= d;
      }
      //*******end secondOp, begin answer
       if (correctAns) {
         answer = secondOp + " = " + totalSoFar;
       }else{ //if we need to give false answer
         boolean inc = ran.nextBoolean(); //if inc, then
         int amount = ran.nextInt(6) + 4;
         if(inc){
           answer =  secondOp + " = " + (totalSoFar + amount);
         }else{
           if((totalSoFar - amount) >=0){
             answer =  secondOp + " = " + (totalSoFar - amount);
           }else{
             answer =  secondOp + " = " + (totalSoFar + amount);
           }
         }
       }

      this.operationArray[k] = answer;
      this.answerArray[k] = correctAns ? true : false;

    }//end for k


  }//end init

}//end class