package operationword;

import java.awt.*;
import java.awt.event.*;
import java.util.Vector;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author tylin
 * @version 1.0
 */

public class TestPanel extends java.awt.Panel {
  Controller controller;
  int totalItems = 0; //total test items
  //Vector answerVector; //to store the answer the user writes
  BorderLayout borderLayout1 = new BorderLayout();
  TextField txtAll[] = new TextField[6];
  Panel MessgePanel = new Panel();
  int wordReplyIndex;
  Label label1 = new Label();
  TextField txt4 = new TextField();
  TextField txt2 = new TextField();
  TextField txt3 = new TextField();
  TextField txt6 = new TextField();
  TextField txt1 = new TextField();
  Panel txtPanel = new Panel();
  TextField txt5 = new TextField();
  Panel butPanel = new Panel();
  Button nextButton = new Button();

  /**
   *
   * @param pItems number of test items
   * pIndex is which index of pCon.wordArray to store the user's reply
   */
  public TestPanel(int pItems, Controller pCon, int pIndex) {
    try {
      this.controller = pCon;
      this.totalItems = pItems;
      this.wordReplyIndex = pIndex;

      jbInit();
      txtAll[0] = txt1;
      txtAll[1] = txt2;
      txtAll[2] = txt3;
      txtAll[3] = txt4;
      txtAll[4] = txt5;
      txtAll[5] = txt6;
      for(int i=0;i<pItems;i++){
        txtAll[i].setEditable(true);
        txtAll[i].setVisible(true);
      }
      this.validate();


    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  //for practice
  public TestPanel(int pItems, Controller pCon) {
    try {
      this.controller = pCon;
      this.totalItems = pItems;
      //this.wordReplyIndex = pIndex;

      jbInit();
      txtAll[0] = txt1;
      txtAll[1] = txt2;
      txtAll[2] = txt3;
      txtAll[3] = txt4;
      txtAll[4] = txt5;
      txtAll[5] = txt6;
      for(int i=0;i<pItems;i++){
        txtAll[i].setEditable(true);
        txtAll[i].setVisible(true);
      }
      this.validate();

    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }



  private void jbInit() throws Exception {
    this.setLayout(borderLayout1);
    this.setBackground(Color.white);
    label1.setFont(new java.awt.Font("Dialog", 1, 14));
    label1.setText("Enter the words in correct sequence.");
    txt4.setColumns(6);
    txt4.setFont(new java.awt.Font("Dialog", 0, 14));
    txt4.setVisible(false);
    txt2.setColumns(6);
    txt2.setFont(new java.awt.Font("Dialog", 0, 14));
    txt2.setVisible(false);
    txt3.setColumns(6);
    txt3.setFont(new java.awt.Font("Dialog", 0, 14));
    txt3.setVisible(false);
    txt6.setColumns(6);
    txt6.setFont(new java.awt.Font("Dialog", 0, 14));
    txt6.setVisible(false);
    txt1.setColumns(6);
    txt1.setFont(new java.awt.Font("Dialog", 0, 14));
    txt1.setVisible(false);
    txt5.setColumns(6);
    txt5.setFont(new java.awt.Font("Dialog", 0, 14));
    txt5.setVisible(false);
    nextButton.setLabel("Next");
    nextButton.setFont(new java.awt.Font("Dialog", 0, 14));
    nextButton.addActionListener(new TestPanel_nextButton_actionAdapter(this));
    this.add(MessgePanel, BorderLayout.NORTH);
    MessgePanel.add(label1, null);
    this.add(txtPanel,  BorderLayout.CENTER);
    txtPanel.add(txt1, null);
    txtPanel.add(txt2, null);
    txtPanel.add(txt3, null);
    txtPanel.add(txt4, null);
    txtPanel.add(txt5, null);
    txtPanel.add(txt6, null);
    txtPanel.add(butPanel, null);
    butPanel.add(nextButton, null);
  }


  void nextButton_actionPerformed(ActionEvent e) {
    if (!this.controller.practiceMode) {
      for (int i = 0; i < this.totalItems; i++) {
        String answer = txtAll[i].getText().trim();
        this.controller.wordReply[this.wordReplyIndex + i] = answer;
        if(answer.compareTo("debug")==0){
          this.controller.step = 75;
        }
      }//end for
      this.controller.nextStep();

    }else{ //practice mode
      this.controller.nextStep();
    }

  }

}

class TestPanel_nextButton_actionAdapter implements java.awt.event.ActionListener {
  TestPanel adaptee;

  TestPanel_nextButton_actionAdapter(TestPanel adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.nextButton_actionPerformed(e);
  }
}
