# MySQL-Front 3.2  (Build 7.19)

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES 'latin1' */;

# Host: post.massey.ac.nz    Database: opword
# ------------------------------------------------------
# Server version 4.1.10a

CREATE DATABASE `opword` /*!40100 DEFAULT CHARACTER SET latin1 */;
USE `opword`;

#
# Table structure for table users
#

CREATE TABLE `users` (
  `userID` varchar(30) NOT NULL default '',
  `userPW` varchar(30) NOT NULL default '',
  `askDemo` char(1) default 'n' COMMENT 'yes or no (y or n), need to ask for demographic info or not',
  `firstName` varchar(50) default NULL,
  `lastName` varchar(50) default NULL,
  `age` char(3) default NULL,
  `background` varchar(100) default NULL,
  `gender` char(1) default NULL COMMENT 'male or femail (m or f)',
  `institution` varchar(100) default NULL,
  `country` varchar(100) default NULL,
  `englishAbility` char(2) default NULL COMMENT '1 to 5, 1 poor, 5 very good',
  `isAdmin` char(1) default 'n' COMMENT 'yes or no',
  PRIMARY KEY  (`userID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

#
# Dumping data for table users
#

INSERT INTO `users` VALUES ('admin','pass','n',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'y');

#
# Table structure for table usertests
#

CREATE TABLE `usertests` (
  `userID` varchar(30) NOT NULL default '',
  `processmeasure` int(3) unsigned NOT NULL default '0',
  `totalmemoryspan` int(3) unsigned NOT NULL default '0',
  `setsizememoryspan` int(3) unsigned NOT NULL default '0',
  `meanresponselatency` bigint(15) default NULL,
  `completeTime` varchar(100) default NULL COMMENT 'time at completion'
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

#
# Dumping data for table usertests
#


/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
