<?php
include_once("zConfig.php");
function server_parse($socket, $expected_response)
{  
   $server_response = '';
	 while (substr($server_response, 3, 1) != ' ')
        {
                if (!($server_response = fgets($socket, 256))){
                  echo('Couldn\'t get mail server response codes. Please contact the administrator.');
									return false;
								}
        }//end while
	
		//echo "$" . $server_response . "<Br>";
      if (strcmp(substr($server_response, 0, 3), trim($expected_response)) == 0){
	      //echo("Correct server response:" . $server_response . "<br>");
				return true;
			}else{
				//echo "subString:" . substr($server_response, 0, 3) . ": expected:" . $expected_response . " compare=" . strcmp(substr($server_response, 0, 3), $expected_response) . "<Br>";
				//echo("Wrong server response:" . $server_response . "<br>");
				return false;
			}//end if
	
}

function smtp_mail($to, $subject, $message, $from, $smtp_server){
	
	
	if (!$smtp_sock = fsockopen($smtp_server, 25, $errno, $errstr, 15)) {
		die ("Couldn't open mail connection to $smtp_server! \n");
	}

	server_parse ($smtp_sock, '220') or die("Cannot get server response before HELO"); 
	fputs($smtp_sock, "HELO $smtp_server\n");
	server_parse ($smtp_sock, '250') or die("Cannot get server response HELO"); 
	fputs($smtp_sock, "MAIL FROM:<$from>\n");
	server_parse ($smtp_sock, '250') or die("Cannot get server response MAIL FROM"); 
	fputs($smtp_sock, "RCPT TO:<$to>\n");
	server_parse ($smtp_sock, '250') or die("Cannot get server response RCPT TO"); 
	fputs($smtp_sock, "NOOP\n");
	server_parse ($smtp_sock, '250') or die("Cannot get server response NOOP"); 
	fputs($smtp_sock, "DATA\n");
	server_parse ($smtp_sock, '354') or die("Cannot get server response DATA"); //need to get a reponse before from
	fputs($smtp_sock, "From: $from\n");
	fputs($smtp_sock, "To: $to\n");
	fputs($smtp_sock, "Subject: $subject\n");
	fputs($smtp_sock, "\r\n");
	fputs($smtp_sock, "$message");
	fputs($smtp_sock, "\r\n");

	fputs($smtp_sock, '.' . "\r\n");
	fputs($smtp_sock, '.' . "\r\n");
	fputs($smtp_sock, '.' . "\r\n");
	fputs($smtp_sock, '.' . "\r\n");
	fputs($smtp_sock, '.' . "\r\n");
	fputs($smtp_sock, '.' . "\r\n");
	fputs($smtp_sock, '.' . "\r\n");
	fputs($smtp_sock, '.' . "\r\n");

	fputs($smtp_sock, "\nQUIT\n");
	fclose($smtp_sock);
	echo $errstr;
	return true;

}//end smtp_mail

?>
